//
//  GIBAppDelegate.m
//  GraphicsInterchangeBox
//
//  Created by Rogelio Gudino on 8/17/13.
//  Copyright (c) 2013 Cananito. All rights reserved.
//

#import "GIBAppDelegate.h"
#import "GIBAuthenticateViewController.h"
#import "GIBMainViewController.h"

@interface GIBAppDelegate ()

@property (nonatomic, strong) GIBAuthenticateViewController *authenticateViewController;
@property (nonatomic, strong) GIBMainViewController *mainViewController;

@end


@implementation GIBAppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    [self setupDropbox];
    
    self.authenticateViewController = [[GIBAuthenticateViewController alloc] initWithNibName:@"GIBAuthenticateViewController" bundle:nil];
    self.mainViewController = [[GIBMainViewController alloc] initWithNibName:@"GIBMainViewController" bundle:nil];
    
    if (![[DBSession sharedSession] isLinked]) {
        [self showAuthenticateViewController];
    } else {
        [self showMainViewController];
    }
}


#pragma mark - Private Methods
- (void)setupDropbox {
    DBSession *session;
    
    session = [[DBSession alloc] initWithAppKey:@"qggkdspspx902j8" appSecret:@"yy10h55a0971j8q" root:kDBRootDropbox];
    [DBSession setSharedSession:session];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(authHelperStateChangedNotification:) name:DBAuthHelperOSXStateChangedNotification object:[DBAuthHelperOSX sharedHelper]];
}

- (void)authHelperStateChangedNotification:(NSNotification *)notification {
    if ([[DBSession sharedSession] isLinked]) {
        [self showMainViewController];
    } else {
        [self showAuthenticateViewController];
    }
}

- (void)showAuthenticateViewController {
    [self.window setContentView:self.authenticateViewController.view];
}

- (void)showMainViewController {
    [self.window setContentView:self.mainViewController.view];
    [self.mainViewController didSetAsContentView];
}

@end
