//
//  GIBMetadataController.m
//  GraphicsInterchangeBox
//
//  Created by Rogelio Gudino on 8/17/13.
//  Copyright (c) 2013 Cananito. All rights reserved.
//

#import "GIBMetadataController.h"

@interface GIBMetadataController () <DBRestClientDelegate>

@property (nonatomic, strong) DBRestClient *restClient;

@end


@implementation GIBMetadataController

#pragma mark - Overriden Methods
- (id)init {
    self = [super init];
    if (self) {
        _restClient = [[DBRestClient alloc] initWithSession:[DBSession sharedSession]];
        _restClient.delegate = self;
    }
    return self;
}


#pragma mark - Public Methods
- (void)fetchMetadataWithCompletionBlock:(GIFFetchMetadataCompletionBlock)completionBlock {
    [self.restClient loadMetadata:@"/Public/GIFs"];
}

- (void)fetchThumbnailForMetadata:(DBMetadata *)metadata withCompletionBlock:(GIFFetchThumbnailCompletiomBlock)completionBlock {
    //
}


#pragma mark - DBRestClientDelegate
- (void)restClient:(DBRestClient *)client loadedMetadata:(DBMetadata *)metadata {
    // http://dl.dropbox.com/u/3716290/GIFs/Funny-Face-Sam-Jackson.gif
    NSLog(@"");
    return;
    [self fetchThumbnailsFromMetadata:metadata];
}

- (void)restClient:(DBRestClient *)client metadataUnchangedAtPath:(NSString *)path {
    
}

- (void)restClient:(DBRestClient *)client loadMetadataFailedWithError:(NSError *)error {
    [[NSAlert alertWithMessageText:@"Couldn't load images!" defaultButton:nil alternateButton:nil otherButton:nil informativeTextWithFormat:@"Sorry, couldn't load your GIFs."] runModal];
}

- (void)restClient:(DBRestClient *)client loadedThumbnail:(NSString *)destPath metadata:(DBMetadata *)metadata {
    //imageView.image = [[NSImage alloc] initWithContentsOfFile:destPath];
}

- (void)restClient:(DBRestClient *)client loadThumbnailFailedWithError:(NSError *)error {
    
}


#pragma mark - Private Methods
- (void)fetchThumbnailsFromMetadata:(DBMetadata *)metadata {
    NSString *thumbnailPath;
    
    for (DBMetadata *childMetadata in metadata.contents) {
        if (![[[childMetadata.path pathExtension] lowercaseString] isEqualToString:@"gif"]) {
            continue;
        }
        thumbnailPath = [self thumbnailPathForChildMetadata:childMetadata];
        [self.restClient loadThumbnail:childMetadata.path ofSize:@"s" intoPath:thumbnailPath];
    }
}

- (NSString *)thumbnailPathForChildMetadata:(DBMetadata *)childMetadata {
    return [NSTemporaryDirectory() stringByAppendingString:childMetadata.path];
}

@end
